<template>
  <div id="class_board_wrapper" class="bt-container">
    <el-breadcrumb style="font-size: 24px; margin-top: 40px; margin-bottom: 40px;" separator="|">
      <template v-if="authType">
        <el-breadcrumb-item v-if="currentTeachingClass(classId) !== undefined && currentTeachingClass(classId) !== null" :to="{ path: '/a/teacher/NNclass/'+classId }">{{ currentTeachingClass(classId).name }}</el-breadcrumb-item>
        <el-breadcrumb-item v-if="currentStudyingClass(classId) !== undefined && currentStudyingClass(classId) !== null" :to="{ path: '/a/teacher/NNclass/'+classId }">{{ currentStudyingClass(classId).name }}</el-breadcrumb-item>
        <el-breadcrumb-item v-if="currentPreviewClass(classId) !== undefined && currentPreviewClass(classId) !== null" :to="{ path: '/a/teacher/NNclass/'+classId }">{{ currentPreviewClass(classId).name }}</el-breadcrumb-item>
        <el-breadcrumb-item v-if="currentOpenPreviewClass(classId) !== undefined && currentOpenPreviewClass(classId) !== null" :to="{ path: '/a/teacher/NNclass/'+classId }">{{ currentOpenPreviewClass(classId).name }}</el-breadcrumb-item>
      </template>
      <template v-if="!authType">
        <el-breadcrumb-item v-if="currentTeachingClass(classId) !== undefined && currentTeachingClass(classId) !== null" :to="{ path: '/a/student/NNclass/'+classId }">{{ currentTeachingClass(classId).name }}</el-breadcrumb-item>
        <el-breadcrumb-item v-if="currentStudyingClass(classId) !== undefined && currentStudyingClass(classId) !== null" :to="{ path: '/a/student/NNclass/'+classId }">{{ currentStudyingClass(classId).name }}</el-breadcrumb-item>
        <el-breadcrumb-item v-if="currentPreviewClass(classId) !== undefined && currentPreviewClass(classId) !== null" :to="{ path: '/a/student/NNclass/'+classId }">{{ currentPreviewClass(classId).name }}</el-breadcrumb-item>
        <el-breadcrumb-item v-if="currentOpenPreviewClass(classId) !== undefined && currentOpenPreviewClass(classId) !== null" :to="{ path: '/a/student/NNclass/'+classId }">{{ currentOpenPreviewClass(classId).name }}</el-breadcrumb-item>
      </template>
      <el-breadcrumb-item>{{ $t('CLASS_MENU.BOARD') }}</el-breadcrumb-item>
      <div style="text-align: right;">
        <a href="javascript:history.back();">
          <el-button size="small">{{ $t('BOARD.BACK') }}</el-button>
        </a>
      </div>
    </el-breadcrumb>

    <el-table
      :data="postList"
      @cell-click="onDetail"
      style="width: 100%"
      :empty-text="$t('BOARD.NODATA')"
    >
      <el-table-column prop="num" :label="$t('LECTURE_LIST.NUMBER')" width="130" sortable column-key="num">
      </el-table-column>
      <el-table-column prop="name" :label="$t('BOARD.TITLE')">
      </el-table-column>
      <el-table-column prop="user.name" :label="$t('BOARD.CREATOR')" width="180">
      </el-table-column>
      <el-table-column prop="created_at" :label="$t('BOARD.REG_DATE')" width="230">
      </el-table-column>
      <el-table-column prop="num_views" :label="$t('BOARD.VIEWS')" width="180" sortable column-key="num_views">
      </el-table-column>
    </el-table>

    <div>
      <el-select v-model="searchType" size="small" style="display: inline-block; width: 100px; margin-top:40px;">
        <el-option
          v-for="option in selectOptionList"
          :key="option.value"
          :label="option.label"
          :value="option.value">
        </el-option>
      </el-select>

      <div style="display: inline-block; width: 200px; margin-top:40px;">
        <el-input :placeholder="$t('STUDENT_MENU.ENT_SEARCH_TERM')" v-model="searchWord" @keyup.enter="onClick('SEARCH')"></el-input>
      </div>

      <el-button @click="onClick('SEARCH')" icon="el-icon-search" circle></el-button>

      <el-button size="small" style="float:right; margin-top:40px;" @click="onClick('WRITE')" plain>{{ $t('BOARD.POST') }}</el-button>

      <el-pagination
        style="display: inline; float: right; margin-top:40px;"
        layout="prev, pager, next"
        @current-change="refreshBoard"
        :total="total">
      </el-pagination>

    </div>
  </div>
</template>

<script>
import { mapState, mapGetters, mapActions } from 'vuex';
import boardService from '../../services/boardService';
import utils from '../../utils';

export default {
  async created() {
    const vm = this;
    vm.$data.postTotalCount = await vm.getPostTotalCount({
      classId: vm.$route.params.classId,
      type: this.$route.query.type !== undefined ? this.$route.query.type : '',
      query: this.$route.query.query !== undefined ? this.$route.query.query : '',
    });
    await vm.refreshBoard();
    vm.postList.forEach(async (x, index) => {
      x.num = index + 1;
    });
  },
  computed: {
    ...mapGetters('NNclass', [
      'currentTeachingClass',
      'currentStudyingClass',
      'currentPreviewClass',
      'currentOpenPreviewClass',
    ]),
    classId() {
      const vm = this;
      return Number.parseInt(vm.$route.params.classId, 10);
    },
    authType() {
      const vm = this;
      const jwt = vm.$store.state.auth.jwt;
      return utils.getAuthTypeFromJwt(jwt);
    },
  },
  methods: {
    ...mapActions('board', [
      'getPostList',
      'getPostTotalCount',
    ]),
    async refreshBoard(pageNum) {
      const vm = this;
      const res = await boardService.NNgetPostList({
        classId: vm.$route.params.classId,
        pageNum: pageNum ? pageNum - 1 : 0,
        type: this.$route.query.type !== undefined ? this.$route.query.type : '',
        query: this.$route.query.query !== undefined ? this.$route.query.query : '',
      });
      vm.postList = res.data.result;
      vm.postList.forEach((x) =>{
        x.created_at = new Date(x.created_at);
        x.created_at.setHours(x.created_at.getHours()-18);
        x.created_at.setMinutes(x.created_at.getMinutes()-8);
        x.created_at.setSeconds(x.created_at.getSeconds()-33);
        x.created_at = utils.formatDate(x.created_at);
        x.created_at = x.created_at.toString();
      });          
      vm.total = res.data.count;
      vm.postList.forEach(async (x, index) => {
        x.num = index + 1;
      });
    },
    onDetail(row) {
      this.$router.push(`/a/class/${this.$route.params.classId}/NNboarddetail/${row.board_id}`);
    },
    onClick(type) {
      const vm = this;
      switch (type) {
        case 'SEARCH': {
          vm.$router.push({ path: `/a/class/${vm.$route.params.classId}/board/${vm.$route.params.pageNum}`, query: { type: `${vm.$data.searchType}`, query: `${vm.$data.searchWord}` } });
          break;
        }
        case 'WRITE': {
          vm.$router.push(`/a/class/${vm.$route.params.classId}/NNboardwrite`);
          break;
        }
        default: {
          throw new Error(`not defined type ${type}`);
        }
      }
    },
  },
  data() {
    return {
      searchType: 'name',
      searchWord: '',
      total: 0,
      pageNum: 1,
      postList: [],
      selectOptionList: [{
        value: 'name',
        label: this.$t('BOARD.TITLE'),
      }, {
        value: 'user',
        label: this.$t('BOARD.CREATOR'),
      }],
    };
  },
};
</script>